/* ============================================================
 * File  : channelbrowser.h
 * Author: Alvaro Gonzalez Sola <cojonuo@gmail.com>
 * Date  : 2008-08-18
 * Description :
 *
 * ChannelBrowser interface
 *
 * Copyright 2008 by Alvaro Gonzalez Sola
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published bythe Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#ifndef CHANNELBROWSER_H
#define CHANNELBROWSER_H

#include <mythtv/libmythui/mythscreentype.h>
#include <mythtv/libmythui/mythuitext.h>
#include <mythtv/libmythui/mythuitextedit.h>
#include <mythtv/libmythui/mythlistbutton.h>
#include <mythtv/libmythui/mythuibuttonlist.h>
#include <mythtv/libmythui/mythuiimage.h>
#include <mythtv/libmythui/mythdialogbox.h>
#include <mythtv/libmythui/mythprogressdialog.h>
#include <mythtv/httpcomms.h>

#include <qstring.h>
#include <QHash>
#include <q3ptrlist.h>

#include "channel.h"
#include "feedchannel.h"

class ChannelBrowser : public MythScreenType
{

Q_OBJECT

public:

    typedef Q3PtrList<Channel> ChannelList;

    ChannelBrowser(MythScreenStack *parent, const char *name);
    ~ChannelBrowser();

    bool Create();
    bool keyPressEvent(QKeyEvent *event);
    void ShowMenu();
    void customEvent(QEvent *event);
    void ShowEditDialog(bool edit);
    void deleteChannel();

    

private:

    //GUI elements
    MythUIButtonList *m_channelList;
    MythUIText *m_infoText;

    MythDialogBox *m_menuPopup;

    ChannelList m_channels;

private slots:
    void selectChannelBrowser(MythUIButtonListItem* selected);
    void LoadChannels();
};

#endif
