/* ============================================================
 * File  : feedchannel.h
 * Author: Alvaro Gonzalez Sola <cojonuo@gmail.com>
 * Date  : 2008-08-18
 * Description :
 *
 * A Feed Channel
 *
 * Copyright 2008 by Alvaro Gonzalez Sola
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published bythe Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#ifndef FEEDCHANNEL_H
#define FEEDCHANNEL_H

#include "channel.h"

class Q3UrlOperator;
class Q3NetworkOperation;

class FeedChannel : public Channel
{
Q_OBJECT

public:


    FeedChannel(QString name, QString url);
    ~FeedChannel();

    void retrieve();

//     QString name(){ return m_name; };
//     Type type(){ return m_type; };
//     void process();
//     TubeVideo::List& videoList() { return m_videoList; };

private:

//     TubeVideo::List parseRSS(QDomDocument domDoc);
//     void parseAtom(QDomDocument domDoc);
//     void ReplaceHtmlChar(QString &s);

//     QString    m_name;
//     QString    m_destDir;
//     QString    m_url;
//     QString    m_desc;
//     QString    m_imageURL;
//     Type m_type;
//     TubeVideo::List m_videoList;

    QByteArray     m_data;
    Q3UrlOperator     *m_urlOp;

signals:

    void finished(FeedChannel* item);

private slots:

    void slotFinished(Q3NetworkOperation*);
    void slotGotData(const QByteArray& data,
                     Q3NetworkOperation* op);

};

#endif
