/* ============================================================
 * File  : main.cpp
 * Author: Alvaro Gonzalez Sola <cojonuo@gmail.com>
 * Date  : 2008-07-30
 * Description :
 *
 * Copyright 2008 by Alvaro Gonzalez Sola
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published bythe Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#ifndef MAIN_CPP
#define MAIN_CPP

using namespace std;

#include <qapplication.h>
#include <unistd.h>

#include <mythtv/mythcontext.h>
#include <mythtv/libmythui/mythmainwindow.h>

#include <mythtv/mythplugin.h>
#include <mythtv/mythpluginapi.h>

#include "dbcheck.h"
#include "channelbrowser.h"
#include "mythtubeconfig.h"

void runTube(void);

int mythplugin_init(const char *libversion)
{

    //need check if database is create and create
    //revise dbcheck on mythnews

    if (!gContext->TestPopupVersion("channel",
                                    libversion,
                                    MYTH_BINARY_VERSION))
        return -1;

    gContext->ActivateSettingsCache(false);
    if (!UpgradeNewsDatabaseSchema())
    {
        VERBOSE(VB_IMPORTANT,
                "Couldn't upgrade database to new schema, exiting.");
        return -1;
    }
    gContext->ActivateSettingsCache(false);

    REG_JUMP("ChannelBrowser", "Internet ChannelBrowser View", "", runTube);

    return 0;
}

void runTube(void)
{
    MythScreenStack *mainStack = GetMythMainWindow()->GetMainStack();

    ChannelBrowser *channels = new ChannelBrowser(mainStack, "channel");
    if (channels->Create())
        mainStack->AddScreen(channels);
}

int mythplugin_run (void)
{
    runTube();
    return 0;
}


int mythplugin_config(void)
{
    MythScreenStack *mainStack = GetMythMainWindow()->GetMainStack();

    MythTubeConfig *mythtubeconfig = new MythTubeConfig(mainStack, "mythtubeconfig");

    if (mythtubeconfig->Create())
        mainStack->AddScreen(mythtubeconfig);

    return 0;
}

#endif
