/* ============================================================
 * File  : mythtubeconfig.h
 * Author: Alvaro Gonzalez Sola <cojonuo@gmail.com>
 * Date  : 2008-08-26
 * Description :
 *
 * MythTube configurator
 *
 * Copyright 2008 by Alvaro Gonzalez Sola
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published bythe Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#ifndef MYTHTUBECONFIG_H
#define MYTHTUBECONFIG_H

#include <mythtv/libmythui/mythscreentype.h>
#include <mythtv/libmythui/mythlistbutton.h>
#include <mythtv/libmythui/mythuibuttonlist.h>

#include <Q3PtrList>

#include "feedchannel.h"

class MythTubeConfig : public MythScreenType{

Q_OBJECT

    public:

        struct ChannelItem{
            QString name;
            QString url;
        };

        typedef Q3PtrList<ChannelItem> ChannelList;

        struct ChannelsCategory{
            QString name;
            ChannelList channels;
        };

        typedef Q3PtrList<ChannelsCategory> CategoryList;

        MythTubeConfig(MythScreenStack *parent, const char *name = 0);
        ~MythTubeConfig();

        bool Create(void);
        bool keyPressEvent(QKeyEvent *event);

        bool loadData();

    private:

        MythUIButtonList *m_siteList;
        MythUIButtonList *m_categoriesList;

        CategoryList *categoryList;

    private slots:

        void toggleItem(MythUIButtonListItem *item);
        void showChannels(MythUIButtonListItem* selected);
};

#endif